@implementation Connection {
  - init {} {
      $super init
      set port 4000
      set host localhost
      set encrypted 1
    }

  - host: anHost {
      set host $anHost
    }

  - host {} {
      return $host
    }

  - port: aPort {
      set port $aPort
    }

  - port {} {
      return $port
    }

  - socket {} {
      return $socket
    }

  - isEncrypted {} {
      return $encrypted
    }

  - enableEncryption {} {
      set encrypted 1
    }

  - disableEncryption {} {
      set encrypted 0
    }

  - send: msg {
      if {$encrypted} {
        msg encrypt
      }
      if [catch {puts $socket $msg} err] {
        puts stderr "$err"
        $self close
      }
      if [catch {flush $socket} err] {
        puts stderr "$err"
        $self close
      }
    }
  - receive {} {
      if [catch {set msg [gets $socket]} err] {
        puts stderr "$err" 
        $self close
        return 
      }
      if {$encrypted} {
        msg decrypt
      }
      return $msg
    }

  - remoteInvocation: { anInvocation } {
      set cmd {@RMI }
      append cmd $anInvocation
      if [$self isAlive] {
        $self send: $cmd
        return [$self receive]
      } else {
        return
      }
    }

  - open {} {
      if [catch {set socket [socket $host $port]} err] {
        puts stderr "couldn't connect to $host at $port ($err)"
        return 0
      } else {
        fconfigure $socket -buffering line -blocking yes
        return 1
      }
    }

  - close {} {
      catch {close $socket}
      set socket {}
    }

  - isAlive {} {
      if {![string length $socket]} { return 0 }
      if [eof $socket] {
        $self close
        return 0
      } else {
        return 1
      }
    }

  - dealloc {} {
      $self close 
      return [$super dealloc]
    }
}
