@implementation DistantObject {

  + newWithHost:andCommand: { aHost aCommand } {
      return [$self newWithConnection: [[Connection new] host: $aHost] \
                           andCommand: $aCommand]
    }

  + newWithHost:port:andCommand: { aHost aPort aCommand } {
      return [$self newWithConnection: [[[Connection new] host: $aHost] port: $aPort] \
                           andCommand: $aCommand]
    }

  + newWithConnection:andCommand: { aConnection aCommand } {
      #- make sure the connection is opened
      if {![$aConnection isAlive] && ![$aConnection open]} {
        puts stderr "couldn't open connection \
          with [$aConnection host] at port [$aConnection port]"
        return
      }
      set remoteId [$aConnection remoteInvocation: $aCommand]
      if {![string length $remoteId]} {
        puts stderr "couldn't create remote object ! \
          (\"$aCommand\" returned nothing)"
        return
      }
      set id [@newInstanceFromClass $self]
      upvar #0 @$id ID
      set ID(connection) $aConnection
      set ID(remoteId) $remoteId
      return $id
    }

  - forwardInvocation: { { anInvocation {} } } {
      #- make sure the connection is opened
      if {![$connection isAlive] && ![$connection open]} {
        puts stderr "couldn't open connection \
          with [$connection host] at port [$connection port]"
        return
      }
      set remoteInvocation "$remoteId "
      append remoteInvocation $anInvocation
      return [$connection remoteInvocation: $remoteInvocation]
    }

  - dealloc {} {
      if [$connection isAlive] {
        $connection remoteInvocation: "catch {$remoteId dealloc}"
      }
      $connection release

      upvar #0 @$self SELF
      rename $self {}
      unset SELF
      return
    }
}
