source oo.tcl
@package core gui

wm geometry . "700x400"

set pool [AutoReleasePool new]

set notebook [[[Notebook new] autorelease] show]
set f1 [$notebook add: Split]

set splitpane [[[[[SplitBox newWithPath: $f1.s] split: 0.5] autorelease] show] label: SplitBox]

foreach box {top bottom} {
  set $box [[[[Box newWithPath: [$splitpane ${box}].f] label: $box] autorelease] show]
}

set listbox [[[ListBox newWithPath: [$top frame].l] autorelease] show]
set text [[[TextBox newWithPath: [$bottom frame].t] autorelease] show]
set f2 [$notebook add: DynamicListBox]
set dynalist [[[[DynamicListBox newWithPath: $f2.f] label: DynamicListBox] autorelease] show]

set f3 [$notebook add: Table]
set table [[[[[TableBox newWithPath: $f3.f] columns: {column1 column2 column3 column4}] autorelease] show] label: TableBox]

set f4 [$notebook add: boxes]
set combo [[[ComboBox newWithPath: $f4.f1] label: ComboBox] autorelease]

for {set i 0} {$i <= 100} {incr i} {
  $listbox add: "option $i"
  $combo add: "option $i"
}
$combo selection: "option 4"

set switchBox [[[[SwitchBox newWithPath: $f4.f2] label: SwitchBox] autorelease] \
                                  items: {{option 1} {option 2} {option 3}}] 
$switchBox switchOn: "option 2"
$switchBox switchOn: "option 3"

set radioBox [[[[RadioBox newWithPath: $f4.f3] label: RadioBox] autorelease] \
                                 list: {{option 1} {option 2} {option 3} {option 4}}]
$radioBox selection: "option 3"

grid [$combo path]
grid [$switchBox path]
grid [$radioBox path]

set f5 [$notebook add: Tree]
set tree [[[[TreeBox newWithPath: $f5.f] autorelease] show] label: TreeBox]

$tree root: tree
$tree add: node1
$tree add: node1/child1
$tree add: node2

$text loadFromFile: test.tcl
for {set r 1} {$r <= 100} {incr r} {
  set record {}
  for {set c 1} {$c <= 4} {incr c} {
    lappend record "row $r column $c"
  }
  $table add: $record
}
bind . <Destroy> "bind . <Destroy> {} ; $pool release"
