
source main.tcl

wm geometry . "700x500"

pool = [AutoReleasePool new]
notebook = [[[Notebook new] autorelease] show]

f = [$notebook add: Text]
txt = [TextBox newWithPath: $f.txt]
set script [info script]
 
with $txt {
 "loadFromFile: $script"
 "label: $script"
 autorelease
 show
}

#- adding Split tab
f = [$notebook add: Split]
s = [SplitBox newWithPath: $f.s] 
with $s {
  autorelease
  show
  "label: SplitBox"
  "split: 0.3"
  "orientation: horizontal"
}

#- adding a listbox in the top of the split
l = [[[[ListBox newWithPath: [$s top].l] label: ListBox] autorelease] show]

#- adding a textbox in the bottom of the split
txt = [TextBox newWithPath: [$s bottom].t] 
with $txt {
  "loadFromFile: $script"
  "label: $script"
  autorelease
  show
}

#- adding a List tab
f = [$notebook add: List]

dynalist = [DynamicListBox newWithPath: $f.f] 
with $dynalist {
  "label: DynamicListBox"
  autorelease
  show
}

#- adding a Table tab
f = [$notebook add: Table]
table = [TableBox newWithPath: $f.f] 
with $table {
  "columns: {column1 column2 column3 column4}"
  "label: TableBox"
  autorelease
  show
}

#- adding misc tab
f = [$notebook add: misc]

p = [ProgressBox newWithPath: $f.progress]
with $p {
  autorelease
  "label: {1 minutes to go}"
  "timer: 60"
  start
}
reset = [button $f.reset -text reset -command "with $p { stop reset start }"]

grid [$p path] $reset

combo = [[[ComboBox newWithPath: $f.combo] \
                    label: ComboBox] \
                    autorelease]

for {set i 0} {$i <= 100} {incr i} {
  $l add: "option $i"
  $combo add: "option $i"
}
$combo selection: "option 4"
grid [$combo path]

switchBox = [SwitchBox newWithPath: $f.switch]
with $switchBox {
  "label: SwitchBox"
  autorelease
  "items: {{option 1} {option 2} {option 3}}"
  "switchOn: {option 2}"
  "switchOn: {option 3}"
}
                          
grid [$switchBox path]

radioBox = [RadioBox newWithPath: $f.radio]
with $radioBox {
  "label: RadioBox"
  autorelease
  "list: {{option 1} {option 2} {option 3} {option 4}}"
  "selection: {option 3}"
}
grid [$radioBox path]

#- adding tree tab
f = [$notebook add: Tree]
tree = [TreeBox newWithPath: $f.f] 
with $tree {
  "label: TreeBox"
  autorelease 
  show
  "root: tree"
  "add: node1"
  "add: node1/child1"
  "add: node2"
}

for {set r 1} {$r <= 100} {incr r} {
  set record {}
  for {set c 1} {$c <= 4} {incr c} {
    lappend record "row $r column $c"
  }
  $table add: $record
}

bind . <Destroy> {
  bind . <Destroy> {}
  $AutoReleasePool release
}

$notebook selection: misc

@showBitmaps
