
#-------------------------------
# make one bigfile from runtime
#-------------------------------
proc @dumpRuntime {} {
  upvar #0 @RUNTIME RUNTIME
  set files $RUNTIME(files)

  #- file containing the runtime load procedure called "@" must be in the first place
  set files [linsert $files 0 main.tcl]

  #- protocols
  foreach protocol $RUNTIME(protocols) {
    upvar #0 @$protocol PROTO
    files addIfNotYetIn: $PROTO(interface)
  }

  #- classes
  foreach class $RUNTIME(classes) {
    upvar #0 @$class CLASS
    foreach type {interface implementation} {
      foreach file [set CLASS($type)] {
        files addIfNotYetIn: $file
      }
    }
  }

  #- dumping runtime into 1 big file
  set out [open mOT.tcl w+]
  set i 1
  foreach file $files {
    puts stderr "$i) $file" ; incr i
    set f [open $file r]
    puts $out "\n#-\n#- beginning of $file\n#-\n"
    puts $out [read $f]
    puts $out "\n#-\n#- end of $file\n#-\n"
    close $f
  }

  close $out
}
