#----------------------
# gets integer maximum 
#----------------------
proc @maxInteger {} {
  set i 1
  set index 1

  while {$i > 0} {
    set i [expr 1 << [incr index]]
  }
  expr 1 << [expr $index - 1]
}

uplevel #0 { 
  set @RUNTIME(maxInteger) [@maxInteger] 
  set @RUNTIME(lastId) 0
  set @RUNTIME(counter) 0
}

#--------------------------------
# gets next available object Id
#--------------------------------
proc @nextId {} {
  upvar #0 @RUNTIME(counter) counter
  upvar #0 @RUNTIME(lastId) lastId
  upvar #0 @RUNTIME(maxInteger) maxInteger

  set maxIntegerLength [string length $maxInteger]
  set len [expr $maxIntegerLength -1]
  set incrementing 1
  set index [expr [llength $counter] -1]

  while {$incrementing} {
    #- incrementing the current counter
    set count [expr [string trimleft [lindex $counter $index] 0] + 1]

    #- have we reached the limit ?
    if {[string length $count] == $maxIntegerLength} {
      #- reset it + report to next counter
      set counter [lreplace $counter $index $index [format %0${len}i 0]]
      incr index -1
      if {$index == -1} {
        #- next counter doesn't exist yet
        set counter [linsert $counter 0 0]
        set index 0
      }
    } else {
      #- no limit reached so, updating counter
      set counter [lreplace $counter $index $index [format %0${len}i $count]]
      set incrementing 0
    }
  }
  set lastId [string trimleft [join $counter {}] 0]
}