#-------------------------------
# extends or return search path 
#-------------------------------
if {![info exists @RUNTIME(path)]} {
  set @RUNTIME(path) .
}
if {![info exists @RUNTIME(packages)]} {
  set @RUNTIME(packages) {}
}

proc @path {{args {}}} {
  upvar #0 @RUNTIME RUNTIME

  if {![string length $args]} { return $RUNTIME(path) }
  set directories [join $args]

  foreach directory $directories {
    set dir1 $directory
    set dir2 [file join $RUNTIME(directory) $directory]

    foreach i {1 2} {
      if [file isdirectory [set dir$i]] {
        if {[file pathtype [set dir$i]] == "relative"} {
          set dir$i [file join [pwd] [set dir$i]]
        }
        if {![RUNTIME(path) contains: [set dir$i]]} {
          if {![RUNTIME(packages) contains: [file tail [set dir$i]]]} {
            lappend RUNTIME(path) [set dir$i]
          }
        }
        break
      }
    }
  }
  set RUNTIME(path)
}


#------------------------------------------
# remote library directory from path name
#------------------------------------------
proc @formatLibraryPathName {path} {
  upvar #0 @RUNTIME RUNTIME
  if [regexp (.*)([string trimright [file join $RUNTIME(directory) " "] " "])(.*) $path -> a b c] {
    set path $c
  }
  set path
}
