proc LaunchAnimation {window} {
  foreach field {rayon angle translation deltaAngle deltaRayon} {
    upvar #0 _Animation($field) $field
  }
  
  set rayon 400.0 
  set deltaRayon 2
  set translation 200
  set angle 0
  set deltaAngle 0.03

  Animate $window
}

proc Animate {window} {
  foreach field {rayon angle translation deltaAngle deltaRayon} {
    upvar #0 _Animation($field) $field
  }

  set x [expr round(($rayon * cos($angle)) + $translation)]
  set y [expr round(($rayon * sin($angle)) + $translation)]
    
  wm geometry $window "+$x+$y"
  update idletasks

  set angle [expr $angle + $deltaAngle]
  set rayon [expr $rayon - $deltaRayon]

  if {$rayon > 0} {
    after 1 [info level 0] 
  }
}

source ../main.tcl

wm geometry . "300x400+100+100"
wm title . IPMon

tree = [[[[TreeBox new] \
                  show] \
                  root: Brussel] \
                 label: Network]
$tree add: cisco1
$tree add: cisco2

LaunchAnimation .
