source ../main.tcl

wm geometry . "600x400+100+100"

package require Tnm
catch {namespace import Tnm::*}

if {$tnm(version) >= 3} {
  set tnm(children) children
  set tnm(name) label
} else {
  set tnm(children) successor
  set tnm(name) name
}

set tnm(cache) [pwd]

set main [[[[SplitBox new] split: 0.8] orientation: horizontal] show]

set topframe [$main top].top
set top [[[[SplitBox newWithPath: $topframe] split: 0.8] orientation: vertical] show]

set leftframe [$top left].tree
set tree [[[[TreeBox newWithPath: $leftframe] root: iso] separator: .] show]
$tree add: org
$tree open: iso
$tree label: iso
$tree selection: iso
$tree onSelection: "ShowChildsOf \$selection"

set Childs(iso) org

set bottomframe [$main bottom].bottom
set table [[[TableBox newWithPath: $bottomframe] show] label: traps]

set rightframe [$top right].right
set detail [[[ScrollableBox newWithPath: $rightframe] show] label: details]

$main maxSplit
$top maxSplit

proc ShowChildsOf selection {
  global tree Childs tnm
  
  if [info exists Childs($selection)] {
  } else {
    GetChildsOf $selection
  }
  $tree label: $selection
  UpdateSelectionDetail $selection
}

proc GetChildsOf selection {
  global tnm Childs tree

  set node [lindex [split $selection .] end]
  set childs [mib $tnm(children) $node]

  $tree busy
  foreach child $childs {
    set child [mib $tnm(name) $child]
    lappend Childs($selection) $child
    $tree addWithoutUpdate: $selection.$child
  }
  $tree redraw
  $tree unbusy
}

bind . <Map> {
  global tnm
  if {![info exists Map]} {
    if [catch {
      if [file exists mibs/mibdb.cnf] { 
        unset tnm(mibs) ; source mibs/mibdb.cnf 
      }
      mib oid internet
    } err] { tk_messageBox -message "$err" }
  }
  set Map 1
}
