
#----------------------------------------------
# return code to get access to class variables 
#   (in a class method)
#----------------------------------------------

proc @getAccessToClassVariables {self} {
  upvar #0 @${self} SELF
  upvar #0 @$SELF(class) CLASS

  set txt "\nset super @sendMessageToSuper\n"

  set type class

  foreach field $CLASS(${type},variables) {
    if {![regexp {^@([^$]+)$} $field -> arrayName]} {
      append txt "upvar #0 @\${self}($field) $field\n"
    } else {
      append txt "upvar #0 @\${self}@${arrayName} $arrayName\n"
    }
  }

  set txt
}


#----------------------------------------------
# return code to get access to instance variables 
#   (in an instance method)
#----------------------------------------------

proc @getAccessToInstanceVariables {self} {
  upvar #0 @${self} SELF
  upvar #0 @$SELF(class) CLASS

  set txt "\nset super @sendMessageToSuper\n"

  set type instance

  foreach field $CLASS(${type},variables) {
    if {![regexp {^@([^$]+)$} $field -> arrayName]} {
      append txt "upvar #0 @\${self}($field) $field\n"
    } else {
      append txt "upvar #0 @\${self}@${arrayName} $arrayName\n"
    }
  }

  set txt
}
